//---------------------------------------------------------------------------


#pragma hdrstop

#include <System.hpp>
#include <Registry.hpp>
#include "Global.h"

//---------------------------------------------------------------------------

AnsiString AppDir = "";
AnsiString WorkDir = "";

AnsiString NextItem(AnsiString &S)
{
  int P = S.Pos(',');
  if (P > 0) {
    AnsiString Result = S.SubString(1, P - 1);
    S.Delete(1, P);
    return Result;
  }
  else{
    AnsiString Result = S;
    S = "";
    return Result;
  }
}


void  LoadFormPosReg(TForm *Form, AnsiString RegKeyName)
{
  TRegIniFile *Reg = new TRegIniFile(RegKeyName);
  try{
    AnsiString S = Reg->ReadString(Form->Name, "Position",
         IntToStr(Form->Left) + ',' + IntToStr(Form->Top) + ',' +
         IntToStr(Form->Width) + ',' + IntToStr(Form->Height));
    Form->Left = StrToInt(NextItem(S));
    Form->Top = StrToInt(NextItem(S));
    Form->Width = StrToInt(NextItem(S));
    Form->Height = StrToInt(NextItem(S));
  }
  __finally{
    delete Reg;
  }
}

void  SaveFormPosReg(TForm *Form, AnsiString RegKeyName)
{
  TRegIniFile *Reg = new TRegIniFile(RegKeyName);
  try{
    Reg->WriteString(Form->Name, "Position",
      IntToStr(Form->Left) + ',' + IntToStr(Form->Top) + ',' +
      IntToStr(Form->Width) + ',' + IntToStr(Form->Height));
  }
  __finally{
    delete Reg;
  }
}

void ReadOptions(void)
{
  TRegIniFile *Reg = new TRegIniFile(RegBaseKey + AnsiString("\\Common"));
  try {
    WorkDir = Reg->ReadString("", "QueryDir", AppDir);
  }
  __finally{
    delete Reg;
  }
}

void SaveOptions(void)
{
  TRegIniFile *Reg = new TRegIniFile(RegBaseKey + AnsiString("\\Common"));
  try{
    Reg->WriteString("", "QueryDir", WorkDir);
  }
  __finally {
    delete Reg;
  }
}

#pragma package(smart_init)
