//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <DDLabel.hpp>
#include "kbdeinfo.hpp"
#include "kdbinfo.hpp"
#include "kdbstruc.hpp"
#include "kqfbase.hpp"
#include "kqrybase.hpp"
#include "kqrycomb.hpp"
#include "kquerpnl.hpp"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <DB.hpp>
#include <DBGrids.hpp>
#include <DBTables.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Menus.hpp>
#include "kstdspnl.hpp"
#include <Db.hpp>
#include "ACRMain.hpp"
#include "ACRsq_dbinfo.hpp"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Toolbar;
        TBevel *Bevel1;
        TBevel *Bevel2;
        TSpeedButton *sbActivateQueryPanel;
        TSpeedButton *sbBuildQuery;
        TSpeedButton *sbSaveQuery;
        TSpeedButton *sbShowSQL;
        TSpeedButton *sbQueryParams;
        TSpeedButton *sbNewQuery;
        TSpeedButton *sbDeleteQuery;
        TKQueryCombo *cbCurQuery;
        TPanel *pnlMain;
        TSplitter *Splitter1;
        TKQueryPanel *QPanel;
        TPageControl *pcSQL;
        TTabSheet *tshSQL;
        TMemo *memSQL;
        TTabSheet *tshResult;
        TDBGrid *DBGrid1;
        TPanel *pnlResControls;
        TSpeedButton *sbText;
        TSpeedButton *sbHTML;
        TSpeedButton *sbDBASE;
        TSpeedButton *sbPrint;
        TSpeedButton *sbPreview;
        TGroupBox *gbResultFields;
        TDropDownLabel *ddlRFields;
        TLabel *lblSortedBy;
        TGroupBox *gbDescription;
        TLabel *lblDescription;
        TMainMenu *mmQueryBuilder;
        TMenuItem *miDatabase;
        TMenuItem *miNewDB;
        TMenuItem *miSelectDB;
        TMenuItem *miEditDBStructure;
        TMenuItem *N3;
        TMenuItem *miExit;
        TMenuItem *miQuery;
        TMenuItem *miNewQuery;
        TMenuItem *miSaveQuery;
        TMenuItem *miQueryParams;
        TMenuItem *miDeleteQuery;
        TMenuItem *Clear1;
        TMenuItem *N6;
        TMenuItem *miParseSQL;
        TMenuItem *N4;
        TMenuItem *miBuildQuery;
        TMenuItem *N2;
        TMenuItem *miResultFields;
        TMenuItem *View1;
        TMenuItem *miActivateQueryPanel;
        TMenuItem *miShowSQL;
        TMenuItem *miShowDescription;
        TMenuItem *N7;
        TMenuItem *miOptions;
        TMenuItem *miResult;
        TMenuItem *SaveAsTextFile1;
        TMenuItem *SaveAsHTML1;
        TMenuItem *SaveAsDBaseTable1;
        TMenuItem *N1;
        TMenuItem *miPreview;
        TMenuItem *miPrint;
        TMenuItem *miHelp;
        TMenuItem *Conten1;
        TMenuItem *N5;
        TMenuItem *miAbout;
        TDataSource *dsResult;
        TKDBStructure *DBStructure;
        TKQueryFileBase *QBase;
        TSaveDialog *SaveDialog;
        TOpenDialog *OpenDialog;
        TACRDatabase *ACRDatabase1;
        TACRsq_dbinfo *BDEInfo;
        TACRQuery *qryResult;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall miNewDBClick(TObject *Sender);
        void __fastcall EditDBStructure(TObject *Sender);
        void __fastcall miSelectDBClick(TObject *Sender);
        void __fastcall miExitClick(TObject *Sender);
        void __fastcall sbActivateQueryPanelClick(TObject *Sender);
        void __fastcall miResultFieldsClick(TObject *Sender);
        void __fastcall ddlRFieldsCustomDropDown(TObject *Sender,
          AnsiString &Value, bool &Accept);
        void __fastcall miNewQueryClick(TObject *Sender);
        void __fastcall EditQueryParams(TObject *Sender);
        void __fastcall SaveCurrentQuery(TObject *Sender);
        void __fastcall DeleteCurrentQuery(TObject *Sender);
        void __fastcall BuildQuery(TObject *Sender);
        void __fastcall sbShowSQLClick(TObject *Sender);
        void __fastcall QPanelActive(TObject *Sender);
        void __fastcall QPanelChange(TObject *Sender);
        void __fastcall QPanelCustomValue(TFilterCond *Condition,
          int ValueIndex, AnsiString &AValue);
        void __fastcall miAboutClick(TObject *Sender);
private:	// User declarations
       void __fastcall EnableControls(void);
       void __fastcall OpenQueryBase(void);
       void __fastcall CheckIsQuerySaved(void);
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
