{*************************************************************}
{                    Simple Query pack                        }
{             Copyright  1998-2001 Korzh.com                 }
{              http://www.korzh.com/delphi/sq/                }
{                  mailto:delphi@korzh.com                    }
{-------------------------------------------------------------}
{                        Demo project                         }
{                  last updated: Mar-05-2001                  }
{*************************************************************}


unit sqd_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, StdCtrls, kdbstruc, kdbinfo, kbdeinfo, Db,
  DBTables, Menus, kquerpnl, KRFldPnl, Grids, DBGrids, ComCtrls, DDLabel,
  ACRsq_dbinfo, ACRMain;

type
  TMainForm = class(TForm)
    Toolbar: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Savestructure1: TMenuItem;
    N2: TMenuItem;
    Savefilter1: TMenuItem;
    N3: TMenuItem;
    Filter1: TMenuItem;
    miActiveFilter: TMenuItem;
    BuildQuery1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Splitter1: TSplitter;
    Bevel1: TBevel;
    Bevel2: TBevel;
    sbActivateFilter: TSpeedButton;
    sbBuildQuery: TSpeedButton;
    sbOpenFilter: TSpeedButton;
    sbSaveFilter: TSpeedButton;
    OpenDialog: TOpenDialog;
    SaveDialog1: TSaveDialog;
    sbSQL: TSpeedButton;
    pcSQL: TPageControl;
    tshSQL: TTabSheet;
    tshResult: TTabSheet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    memSQL: TMemo;
    Editresultfields1: TMenuItem;
    KDBStructure1: TKDBStructure;
    N4: TMenuItem;
    N5: TMenuItem;
    miParseSQL: TMenuItem;
    gbResultFields: TGroupBox;
    RFPanel: TKResultFieldsPanel;
    gbQueryPanel: TGroupBox;
    sbClearQuery: TSpeedButton;
    ddlResultFields: TDropDownLabel;
    QPanel: TKQueryPanel;
    Splitter2: TSplitter;
    btCodeSamples: TButton;
    pmCodeSamples: TPopupMenu;
    Manualaddresultfieldsexample1: TMenuItem;
    DeleteFieldsbyTable1: TMenuItem;
    DeleteLinksByTable1: TMenuItem;
    RetrieveDatabaseInformation1: TMenuItem;
    ACRsq_dbinfo1: TACRsq_dbinfo;
    ACRDatabase1: TACRDatabase;
    Query1: TACRQuery;
    procedure sbEditStructureClick(Sender: TObject);
    procedure sbBuildQueryClick(Sender: TObject);
    procedure sbActivateFilterClick(Sender: TObject);
    procedure sbSQLClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure sbOpenFilterClick(Sender: TObject);
    procedure sbSaveFilterClick(Sender: TObject);                       
    procedure QPanelActive(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure QPanelCustomValue(Condition: TFilterCond;
       ValueIndex: Integer; var AValue: String);
    procedure QPanelValueDblClick(Condition: TFilterCond; ValueIndex : integer; var AValue : string);
    procedure ddlRFieldsCustomDropDown(Sender: TObject; var Value: String;
      var Accept: Boolean);
    procedure QPanelConditionChange(Condition: TFilterCond;
      WhatChanged: Integer);
    procedure FormCreate(Sender: TObject);
    procedure miParseSQLClick(Sender: TObject);
    procedure RFPanelChange(Sender: TObject);
    procedure sbClearQueryClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Manualaddresultfieldsexample1Click(Sender: TObject);
    procedure DeleteFieldsbyTable1Click(Sender: TObject);
    procedure DeleteLinksByTable1Click(Sender: TObject);
    procedure QPanelSetValue(Condition: TFilterCond; ValueIndex: Integer;
      AValue: String; var ACaption: String);
    procedure RetrieveDatabaseInformation1Click(Sender: TObject);
    procedure KBDEInfo1LinksRequest(Sender: TObject; ALinks: TStrings);
    procedure btCodeSamplesClick(Sender: TObject);
  private
    bInside : boolean;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses About, DateDlg;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  bInside := false;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  QPanel.Activate;
  RFPanel.Activate;
end;

procedure TMainForm.sbEditStructureClick(Sender: TObject);
var
  Strings : TStrings;
begin
  // you have to save current query before structure changing
  // and then load it to prevent links loss to TDSTable, TDSField
  // and TDSOperat objects stored in TKDBStructure

  Strings := TStringList.Create;
  try
    QPanel.SaveToStrings(Strings);
    KDBStructure1.EditStructure;
    try
      QPanel.LoadFromStrings(Strings);
    except
      //structure was changed - need to clear the structure
      QPanel.ClearAll;
    end;
    if KDBStructure1.DefaultMainTable <> nil then
      QPanel.MainTableName := KDBStructure1.DefaultMainTable.TableName;
  finally
    Strings.Free;
  end;
end;

procedure TMainForm.sbBuildQueryClick(Sender: TObject);
var
  i : integer;
begin
  Screen.Cursor := crHourGlass;
  try
//    QPanel.QResult.ResultFields.Assign(RFPanel.ResultFields);
    QPanel.BuildQuery;
    memSQL.Lines.Assign(QPanel.QResult.SQL);
    with Query1 do
    begin
      if Active then Close;
      SQL := memSQL.Lines;
//      DatabaseName := KBDEInfo1.DatabaseName;
      Open;
      for i := 0 to QPanel.QResult.RFields.Count - 1 do
        Fields[i].DisplayLabel := QPanel.QResult.RFields[i].Caption;
    end;
  finally;
    Screen.Cursor := crDefault;
  end;
end;

procedure TMainForm.sbActivateFilterClick(Sender: TObject);
begin
  QPanel.Active := not QPanel.Active;
  RFPanel.Active := not RFPanel.Active;
end;

procedure TMainForm.QPanelActive(Sender: TObject);
begin
  sbActivateFilter.Down  := QPanel.Active;
  miActiveFilter.Checked := QPanel.Active;
end;

procedure TMainForm.sbSQLClick(Sender: TObject);
begin
  pcSQL.Visible := (Sender as TSpeedButton).Down;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.sbOpenFilterClick(Sender: TObject);
begin
  OpenDialog.Filter := 'Query files|*.qry';
  if not OpenDialog.Execute then exit;
  QPanel.LoadFromFile(OpenDialog.FileName);
  RFPanel.ResultFields := QPanel.QResult.ResultFields;
end;

procedure TMainForm.sbSaveFilterClick(Sender: TObject);
begin
  if not SaveDialog1.Execute then exit;
  QPanel.SaveToFile(SaveDialog1.FileName);
end;


procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutBox := TAboutBox.Create(Application);
  AboutBox.ShowModal;
  AboutBox.Free;
end;


procedure TMainForm.QPanelSetValue(Condition: TFilterCond;
  ValueIndex: Integer; AValue: String; var ACaption: String);
begin
 if Condition.ValueType[ValueIndex] in [ftDate, ftDateTime] then
  try
    ACaption := FormatDateTime('dddddd', StrToDate(AValue));
  except
    ACaption := LabelSpace;
  end;
end;

procedure TMainForm.QPanelCustomValue(Condition: TFilterCond;
  ValueIndex: Integer; var AValue : String);
begin
  if Condition.ValueType[ValueIndex] in [ftDate, ftDateTime] then
  begin
    DateDialog := TDateDialog.Create(nil);
    if AValue = '' then
      DateDialog.Date := Date
    else
      try
        DateDialog.Date := StrToDate(AValue);
      except
        DateDialog.Date := Date;
      end;
    DateDialog.ShowModal;

    if DateDialog.ModalResult = mrOK then
      AValue := DateToStr(DateDialog.Date);
    DateDialog.Free;
  end;
end;

procedure TMainForm.QPanelValueDblClick(Condition: TFilterCond; ValueIndex : integer; var AValue : string);
begin
  if Condition is TSimpleCond then
    ShowMessage('DblClick on field: ' + TSimpleCond(Condition).Field.DisplayName);
end;

procedure TMainForm.ddlRFieldsCustomDropDown(Sender: TObject;
  var Value: String; var Accept: Boolean);
begin
  Accept := QPanel.EditQResult;
  if Accept then
    Value := QPanel.QResult.RFields.Caption;
end;

procedure TMainForm.QPanelConditionChange(Condition: TFilterCond;
  WhatChanged: Integer);
begin
  if bInside then Exit;
  bInside := True;
//  Condition.Value1 := UpperCase(Condition.Value1);
  bInside := False;

{  if (WhatChanged = 1) and TSimpleCond(Condition).Field.EditType = etEdit then
  begin
    if TDSTextEditor(TSimpleCond(Condition).Field.ValueEditor).Kind = tekMask then
      TDSTextEditor(TSimpleCond(Condition).Field.ValueEditor).EditMask := '!\(999\)000-0000;1;_';
  end;
}  
end;

procedure TMainForm.miParseSQLClick(Sender: TObject);
var
  SQLText : TStrings;
begin
  OpenDialog.Filter := 'SQL script files|*.sql;*.txt';
  if OpenDialog.Execute then
  begin
    SQLText := TStringList.Create;
    try
      SQLText.LoadFromFile(OpenDialog.FileName);
      QPanel.ParseSQL(SQLText);
      RFPanel.ResultFields := QPanel.QResult.ResultFields;
    finally
      SQLText.Free;
    end;
  end;
end;

procedure TMainForm.RFPanelChange(Sender: TObject);
begin
  QPanel.QResult.ResultFields := RFPanel.ResultFields;
end;

procedure TMainForm.sbClearQueryClick(Sender: TObject);
begin
  QPanel.ClearAll;
  RFPanel.ClearAll;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  QPanel.Appearance.Style := TQPStyle(ord(not boolean(ord(QPanel.Appearance.Style))));
(*
  QPanel.QResult.ResultFields.AddByFormula('Patient ID', '{ID}', stNoSort, 0);
  if aoShowCheckBoxes in QPanel.Appearance.Options then
    QPanel.Appearance.Options := QPanel.Appearance.Options - [aoShowCheckBoxes]
  else
    QPanel.Appearance.Options := QPanel.Appearance.Options + [aoShowCheckBoxes];
  *)
end;

procedure TMainForm.Manualaddresultfieldsexample1Click(Sender: TObject);
begin
  with QPanel.QResult.ResultFields do
  begin
    Clear;
    AddBySQLExpr('Company', 'C.Company', stAscending, 1);
    AddBySQLExpr('Employee', 'E.FirstName || '' '' || E.LastName', stAscending, 2);
    AddBySQLExpr('Sales', 'SUM(P.Cost)', stNoSort, 0);
  end;
  ddlResultFields.Value := QPanel.QResult.ResultFields.Caption;
end;

procedure TMainForm.DeleteFieldsbyTable1Click(Sender: TObject);
var
  DSTable : TDSTable;
  I : integer;
begin
  with KDBStructure1 do
  begin
    DSTable := TableByName(0, 'Parts');
    if DSTable = nil then
      raise Exception.Create('No such table');
    for i := Fields.Count - 1 downto 0 do
    begin
      if (Fields[I].Tables.Count > 0) and (Fields[I].Tables[0] = DSTable) then
        DelField(I);
    end;
  end;
end;

procedure TMainForm.DeleteLinksByTable1Click(Sender: TObject);
var
  DSTable : TDSTable;
  I : integer;
begin
  with KDBStructure1 do
  begin
    DSTable := TableByName(0, 'Parts');
    if DSTable = nil then
      raise Exception.Create('No such table');
    for I := DSTable.LinkCount - 1 downto 0 do
      DSTable.DelLink(I);
  end;
end;

procedure TMainForm.RetrieveDatabaseInformation1Click(Sender: TObject);
begin
  KDbStructure1.ClearStructure;
  KDbStructure1.RetriveDataModelInfo;
end;

procedure TMainForm.KBDEInfo1LinksRequest(Sender: TObject;
  ALinks: TStrings);
begin
  ALinks.Add('CUSTOMER-ORDERS:CustNo=CustNo');
  ALinks.Add('EMPLOYEE-ORDERS:EmpNo=EmpNo');
  ALinks.Add('ITEMS-ORDERS:OrderNo=OrderNo');
  ALinks.Add('ITEMS-PARTS:PartNo=PartNo');
  ALinks.Add('PARTS-VENDORS:VendorNo=VendorNo');
end;

procedure TMainForm.btCodeSamplesClick(Sender: TObject);
var
  P : TPoint;
begin
  P := Point(btCodeSamples.Left, btCodeSamples.Top);
  P := btCodeSamples.Parent.ClientToScreen(P);
  inc(P.Y, btCodeSamples.Height);
  pmCodeSamples.Popup(P.X, P.Y);
end;

end.
